#!/usr/bin/python

import re, sys

if len(sys.argv) < 2:
	print >>sys.stderr, 'Usage:\n\t%s m-file' % sys.argv[0]
	sys.exit(1)

mfile = file(sys.argv[-1])
line = mfile.read().split('\n')[0]
if not line.startswith('function'):
	print >>sys.stderr, \
		'\'%s\' does not contain a function declaration.' % sys.argv[-1]
	sys.exit(1)
mfile.close()

# Simple parser for Matlab function declarations
line = re.sub('function *', '', line).split('=')
res = line[0].strip()
line = line[1].strip()[:-1].split('(')
name = line[0].strip()

args = [arg.strip() for arg in line[1].strip().split(',')]
templargs = [arg.upper() for arg in args]
arglist = ','.join(['%s %s' % (templargs[i], args[i]) for i in range(len(args))])
args2 = ','.join(['MW%s(%s)' % (arg, arg) for arg in args])
args = ','.join(['MW%s' % arg for arg in args])
templargs = ','.join(['class %s' % arg for arg in templargs])

out = file('mlab_%s.h' % name, 'w')
out.write("""#include "lib%s.h"

template<class RET,%s> RET %s (%s)
{
	lib%sInitialize();
	mwArray MWret, %s;
	%s(1, MWret, %s);
	RET ret = (RET)MWret;
	lib%sTerminate();
	return ret;
}
""" % (name, templargs, name, arglist, name, args2, name, args, name))
out.close()
