package CTL;

import CTL.Comm.*;
import CTL.Types.*;

import java.util.*;

/** Global environment */
public class Env
{
	/** Map with all allocated objects and their IDs */
	public static ObjectMap map;
	/** Logging handler */
	public static Logger log;
	/** Remote debugger */
	public static PeerID debugger = null;
	/** Map of custom AnyObj identifier strings */
	public static AnyObjIdentMap AnyObjIdent;
	/** List of running CTL.Processes */
	public static LinkedList<CTL.Process> procs;
	/** List of available Environments */
	private static LinkedList<Env> envs;
	/** JVM's listening port for debuggers */
	public static int debugID = -1;
	
	public static boolean clean = false;
	public static boolean daemon = false;
	public static boolean isDebugger = false;

	/** Process group */
	public Group grp;
	/** Communicator */
	public Communicator[] comm;

	static
	{
		log = null;
		map = new ObjectMap();
		AnyObjIdent = new AnyObjIdentMap();
		procs = new LinkedList<CTL.Process>();
		envs = new LinkedList<Env>();
	}

	private Env ()
	{
		comm = null;
		grp = null;
	}

	public static Env newEnv ()
	{
		Env env = new Env();
		envs.add(env);
		return env;
	}

	public static Logger newLogger (String fname)
	{
		if (log == null)
			log = new Logger(fname, Globals.LogLevel);
		return log;
	}
}
