package CTL.Streams;

import CTL.Types.*;
import ReflWrap.TypeTree;

import java.io.*;
import java.lang.reflect.*;
import java.util.LinkedList;

/** Interface for CTL input streams */
public interface InStream extends DataInput
{
	public String readString () throws IOException;
	public String readWString () throws IOException;
	
	public <T extends Object> T[] readArray (Class<T> type, 
		LinkedList<TypeTree> params) throws IOException, 
		ClassNotFoundException, InstantiationException, 
		IllegalAccessException, InvocationTargetException;
	public <T extends Object> T[] __readArray (Class<T> type, 
		LinkedList<TypeTree> params, int len) throws IOException, 
		ClassNotFoundException, InstantiationException, IllegalAccessException, 
		InvocationTargetException;
	public Tupel readTupel (Class[] types) throws IOException, 
		ClassNotFoundException, InstantiationException, IllegalAccessException,
		InvocationTargetException, CTLException;
	
	public Object readObject () throws IOException, 
		ClassNotFoundException, InstantiationException, IllegalAccessException,
		InvocationTargetException;
	public Object serialRead (Class... args) throws IOException, 
		ClassNotFoundException, InstantiationException, 
		IllegalAccessException, InvocationTargetException;
	public <T extends Object> T serialRead (Class<T> klass) throws 
		IOException, ClassNotFoundException, InstantiationException,
		IllegalAccessException, InvocationTargetException;
	public Object serialRead (TypeTree tree) throws IOException, 
		ClassNotFoundException, InstantiationException, 
		IllegalAccessException, InvocationTargetException;
}
