package CodeGen;

/** CodeGen - code generator for CTL remote interfaces */
public class Main
{
	public static void main (String[] args)
	{
		try
		{
			for (int i=0;i<args.length;i++)
			{
				if (args[i].equals(""))
					continue;
				Gen g = new GenRI(args[i]);
				g.generate();
				if (!g.isCC())
				{
					new GenCI(args[i]).generate();
					new GenLocal(args[i]).generate();
					try
					{
						Class.forName("Debug.Debugger.DebuggerMain");
						new GenDebug(args[i]).generate();
					}
					catch (ClassNotFoundException e)
					{
						//e.printStackTrace();
					}
				}
			}
		}
		catch (Exception e)
		{
			System.out.println("CodeGen: main():\n\t"+e);
			e.printStackTrace();
		}
	}
}
