package Hitman;

import java.text.*;
import java.util.*;

/** Date parser and formatter (Wrapper around DateFormat) */
public class Dating
{
	/** Date formatter */
	private static DateFormat fmt = null;

	static 
	{
		fmt = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss zzz", 
				Locale.US);
		fmt.setTimeZone(TimeZone.getDefault());
	}

	/** Parse a date
	 * @param str String to parse
	 * @return Date object representing the date
	 */
	public static Date parse (String str)
	{
		try
		{
			return fmt.parse(str);
		} 
		catch (ParseException e) 
		{
			e.printStackTrace();
			return null;
		}
	}

	/** Format a date
	 * @param date Date object
	 * @return String representing the date
	 */
	public static String format (Date date)
	{
		return fmt.format(date);
	}

	/** Test code */
	public static void main (String[] args)
	{
		System.out.println(parse("Sat, 16 Apr 2005 22:16:19 GMT"));
	}
}
