package Impl;

import Impl.Types.*;

/** Call-by-reference example.
 * This class, Impl.Types.MyRef and Example.Client3 demonstrate how to emulate
 * call-by-reference in Java. You cannot simply modify ref and return something
 * else, because Java actually uses call-by-value for reference types, too. The
 * ref inside test() is a copy of the ref the caller passed to the method.
 * Therefore, the user code needs to set its ref to the ref returned by test().
 */
public class CallByReference
{
	public MyRef test (MyRef ref)
	{
		ref.i = ref.i + 7;
		ref.str = "call-by-reference!";
		return ref;
	}
}
