package Test;

import CTL.Types.*;

import java.net.*;
import junit.framework.*;

/** Test case for the IPaddr type
 * @see CTL.Types.IPaddr
 */
public class TIPaddr extends TestCase
{
	public void testIPaddr1 () throws UnknownHostException
	{
		InetAddress test = InetAddress.getLocalHost();
		IPaddr[] tst = new IPaddr[6];
		tst[0] = new IPaddr();
		tst[1] = new IPaddr(tst[0].getUint32());
		tst[2] = new IPaddr("127.0.0.1");
		tst[3] = new IPaddr("localhost");
		tst[4] = new IPaddr(test);
		tst[5] = new IPaddr(IPaddr.getUint32(test));
		
		for (int i=0;i<tst.length;i++)
			assertTrue((tst[i]!=null)&&(tst[i].equals(test)));
	}

	public void testIPaddr2 () throws UnknownHostException
	{
		// Note: Does not work, probably due to signed vs. unsigned 
		// (+0 and -0, therefore we lose one bit)
		String adr = "255.255.255.255";
		//String adr = "134.169.23.7";
		InetAddress test = InetAddress.getByName(adr);
		IPaddr[] tst = new IPaddr[4];
		tst[0] = new IPaddr(adr);
		tst[1] = new IPaddr(tst[0].getUint32());
		tst[2] = new IPaddr(test);
		tst[3] = new IPaddr(IPaddr.getUint32(test));
		
		for (int i=0;i<tst.length;i++)
		{
			System.out.println(IPaddr.setUint32(tst[i].getUint32()));
			assertTrue((tst[i]!=null)&&(tst[i].equals(test)));
		}
	}

	public static void main (String[] args)
	{
		try
		{
			TIPaddr moo = new TIPaddr();
			moo.testIPaddr1();
			moo.testIPaddr2();
		} catch (UnknownHostException e) {}
	}
}
