package Test;

import CTL.*;
import CTL.Streams.*;
import CTL.Types.*;

import java.io.*;
import junit.framework.*;

/** Test case for CTL.Reference */
public class TRef extends TestCase
{
	public void testReference ()
	{
		try
		{
			Env.newLogger("test");
			
			Reference<String> moo1 = new Reference<String>("foo");
			Reference<String> moo2 = new Reference<String>("bar");
			Reference<String> moo3 = new Reference<String>("foo");

			PipedOutputStream pout = new PipedOutputStream();
			PipedInputStream pin = new PipedInputStream(pout);
			OOStream out = new OOStream(pout);
			OIStream in = new OIStream(pin);

			out.serialWrite(moo1);
			out.serialWrite(moo2);
			out.serialWrite(moo3);
			out.flush();
			Reference.cleanup();

			Reference<String> foo1 = (Reference<String>)in.serialRead(
				Reference.class, String.class);
			Reference<String> foo2 = (Reference<String>)in.serialRead(
				Reference.class, String.class);
			Reference<String> foo3 = (Reference<String>)in.serialRead(
				Reference.class, String.class);

			assertTrue(moo1.equals(foo1));
			assertTrue(moo2.equals(foo2));
			assertTrue(moo3.equals(foo3));
		}
		catch (Exception e)
		{
			RUtil.except(e);
		}
	}

	public static void main (String[] args)
	{
		TRef moo = new TRef();
		moo.testReference();
	}
}
